网页教学网
 当前位置: 网页教学网 >> 网络编程 >> JSP编程技术 >> 对于JAVA基础测试中常见的异常问题汇总
[ HTML ] [ FW ] [ DW ] [ FP ] [ JS ] [ XML ] [ CSS ] [ 图象 ] [ FLASH ] [ .NET ] [ ASP ] [ JSP ] [ PHP ] [ 数据 ] [ 系统 ] [ 安全 ] [ 素材 ] [ 建站 ] [ 主机 ] [ 入门 ] [ 技巧 ]

对于JAVA基础测试中常见的异常问题汇总

http://www.webjx.com  更新日期:2007-10-17 09:34  出处:网页教学网  作者:站长整理

1、第一个JAVA例程:hello world

执行时的问题:problems Executing Hello

如果你看到下面的错误提示:

'java' is not recognized as an internal or external command, ...
or
java: Command not found.

那么你或许没有安装java或者在环境变量中并没有设置path路径java\bin目录。

请检查你的java安装以及环境变量的正确设置。

如果你看到:

Exception in thread "main" java.lang.NoClassDefFoundError: hello

(wrong name: Hello) ...

那么你很有可能是因为没有注意大小写或是把名称中的字母打错了。如:

java hello

键入正确的命令重新运行即可。

如果你看到:

Exception in thread "main" java.lang.NoClassDefFoundError: Hello

/class

那么你需要考虑是否去掉名字中的.class部分。


2、分析出现java.lang.NoClassDefFoundError异常的具体情况

这个问题在上面调试第一个例程出现过,但是如果我们输入的名称是正确的,仍然提示这样的问题时怎么办呢?

装了JDK1.4.0版,而且JAVA_HOME,PATH和CLASSPATH都设置好了。如下

JAVA_HOME=/home/jdk

CLASSPATH=$JAVA_HOME/jre/lib/tools.jar:$JAVA_HOME/lib/dt.jar:$JAVA_HOME/jre/lib/:$JAVA_HOME/lib

PATH=$PATH:$JAVA_HOME/bin

用JAVAC命令生成了hello.class,当使用java hello时,仍然提示:

Exception in thread "main" java.lang.NoClassDefFoundError:XXX(wrong name: XXX)

解决提示:

(1)、Add (current directory) to your classpath或类定义前面加public

(2)、path环境变量中设置的路径中是否有另一个java.exe文件,默认执行的是这个目录下的java.exe,虽然版本与JDK下的java.exe一致,但是在此目录下执行就会出错。

方法:

安装了JDK的情况下,应该删除winnt下的java.exe,确保默认调用的java.exe是位于jdk中bin目录下的java.exe。

(3)、假如你使用了packet

那么检查你在编译了没有将指定package包在你文件中的java文件。

3、通常异常捕获处理:

JAVA中几个基本异常简单的描述一下:

ArithmeticException 当出现异常算术条件时产生

NullPointerException 当应用程序企图使用需要的对象处为空时产生

ArrayIndexOutOfBoundsException 数组下标越界时产生

ArrayStoreException 当程序试图存储数组中错误的类型数据时产生

FileNotFoundException 试图访问的文件不存在时产生

IOException 由于一般I/O故障而引起的,如读文件故障

NumberFormatException 当把字符串转换为数值型数据失败时产生

OutOfMemoryException 内存不足时产生

SecurityException 当小应用程序(Applet)试图执行由于浏览器的安全设置而不允许的动作时产生

StackOverflowException 当系统的堆栈空间用完时产生

StringIndexOutOfBoundsException 当程序试图访问串中不存在的字符位置时产生

上述出现的异常基本上都是JAVA中我们可能会遇到的异常。

类Throwable有两个直接子类:Error和Exception。Exception类对象是Java程序处理或抛弃的对象。Java 提供了两种Exception 的模式,一种是执行的时候所产生的Exception (Runtime Exception),另外一种则是受控制的Exception (Checked Exception)。所有的Checked Exception 均从java.lang.Exception 继承而来,而Runtime Exception 则继承java.lang.RuntimeException 或java.lang.Error (实际上java.lang.RuntimeException 的上一层也是java.lang.Exception)。它有各种不同的子类分别对应于不同类型的例外。其中类RuntimeException代表运行时由Java虚拟机生成的例外。

程序的运作机制上看,Runtime Exception与Checked Exception 不一样,从逻辑上看,Runtime Exception 与Checked Exception 在使用的目的上也不一样。

一般而言,Checked Exception 表示这个Exception 必须要被处理,也就是说程序设计者应该已经知道可能会收到某个Exception(因为要try catch住) ,所以程序设计者应该能针对这些不同的Checked Exception 做出不同的处理。

而Runtime Exception 通常会暗示着程序上的错误,这种错误会导致程序设计者无法处理,而造成程序无法继续执行下去。

Java的可控制异常处理是通过5个关键字来实现的:try,catch,throw,throws,finally。JB的在线帮助中对这几个关键字是这样解释的:

Throws: Lists the exceptions a method could throw.

Throw: Transfers control of the method to the exception handler.

Try: Opening exception-handling statement.

Catch: Captures the exception.

Finally: Runs its code before terminating the program.

·try语句 

try语句用大括号{}指定了一段代码,该段代码可能会抛弃一个或多个例外。

·catch语句 

catch语句的参数类似于方法的声明,包括一个例外类型和一个例外对象。例外类型必须为Throwable类的子类,它指明了catch语句所处理的例外类型,例外对象则由运行时系统在try所指定的代码块中生成并被捕获,大括号中包含对象的处理,其中可以调用对象的方法。

catch语句可以有多个,分别处理不同类的例外。Java运行时系统从上到下分别对每个catch语句处理的例外类型进行检测,直到找到类型相匹配的catch语句为止。这里,类型匹配指catch所处理的例外类型与生成的例外对象的类型完全一致或者是它的父类,因此,catch语句的排列顺序应该是从特殊到一般。

也可以用一个catch语句处理多个例外类型,这时它的例外类型参数应该是这多个例外类型的父类,程序设计中要根据具体的情况来选择catch语句的例外处理类型。

· finally语句 

try所限定的代码中,当抛弃一个例外时,其后的代码不会被执行。通过finally语句可以指定一块代码。无论try所指定的程序块中抛弃或不抛弃例外,也无论catch语句的例外类型是否与所抛弃的例外的类型一致,finally所指定的代码都要被执行,它提供了统一的出口。通常在finally语句中可以进行资源的清除工作。如关闭打开的文件等。不管异常是否发生都会执行finally中的语句。

·throws语句 

throws总是出现在一个函数头中,用来标明该成员函数可能抛出的各种异常。对大多数Exception子类来说,Java 编译器会强迫你声明在一个成员函数中抛出的异常的类型。如果异常的类型是Error或 RuntimeException, 或它们的子类,这个规则不起作用, 因为这在程序的正常部分中是不期待出现的。 如果你想明确地抛出一个RuntimeException,你必须用throws语句来声明它的类型。

· throw语句 

throw总是出现在函数体中,用来抛出一个异常。程序会在throw语句后立即终止,它后面的语句执行不到,然后在包含它的所有try块中(可能在上层调用函数中)从里向外寻找含有与其匹配的catch子句的try块。所有的方法都使用“throw”语句来抛出一个异常。Throw语句需要一个单独throwable对象,这个对象是任意Throwable类的子类。

例如:

boolean testEx() throws Exception{
        boolean ret = true;
        try
    {
            ret = testEx1();
        }
        catch (Exception e)
       {
            System.out.println("testEx, catch exception");
            ret = false;
            throw e;
        }
       finally
      {
            System.out.println("testEx, finally; return value="+ret);
            return ret;
        }
    }

4、JAVA错误: java.lang.Error

原因:

1)对系统所访问外部资源,未执行关闭操作,导致外部资源大量浪费,最终可能导致系统无法正常运行;

2)对系统所访问的外部资源关闭次数太多,外部系统无法正常处理;

3)系统访问的外部资源出现异常情况。

解决方案:

1)访问外部资源前,首先检查该资源(如数据库)是否可正常连接或操作。

2)访问外部资源时,如果进行了连接,一定进行关闭操作,并仅进行一次关闭操作。

3)尽量在同一操作中共享外部资源,以减少该操作对资源的消费,提高程序的执行效率

5、空指针错误 :java.lang.NullPointerException

使用基本的JAVA数据类型,变量的值要么已经是默认值,如果没有对其正常赋值,程序便不能通过编译,因此使用基本的JAVA数据类型(double,float,boolean,char,int,long)一般不会引起空指针异常。由此可见,空指针异常主要跟与对象的操作相关。


下面先列出了可能发生空指针异常的几种情况及相应解决方案:


不管对象是否为空就直接开始使用。

(JSP)代码段1:

out.println(request.getParameter("username"));

描述:

代码段1的功能十分简单,就是输出用户输入的表域"username"的值。

说明:

看上去,上面的语句找不出什么语法错误,而且在大多数情况下也遇不到什么问题。但是,如果某个用户在输入数据时并没有提供表单域"username"的值,或通过某种途径绕过表单直接输入时,此时request.getParameter("username")的值为空(不是空字符串,是空对象null。),out对象的println方法是无法直接对空对象操作,因此代码段1所在的JSP页面将会抛出"java.lang.NullPointerException"异常。

即使对象可能为空时,也调用java.lang.Object或Object对象本身的一些方法如toString(), equals(Object obj)等操作。

(JSP)代码段2:

String userName = request.getParameter("username");
If (userName.equals("root"))
{....}

描述:

代码段2的功能是检测用户提供的用户名,如果是用户名称为"root"的用户时,就执行一些特别的操作。

说明:

在代码段2中,如果有用户没有提供表单域"username"的值时,字符串对象userName为null值,不能够将一个null的对象与另一个对象直接比较,同样,代码段2所在的JSP页面就会抛出(java.lang.NullPointerException)空指针错误。

(JSP)代码段3:

String userName = session.getAttribute("session.username").toString();

描述:

代码段3的功能是将session中session.username的值取出,并将该值赋给字符串对象 userName。

说明:

在一般情况下,如果在用户已经进行某个会话,则不会出现什么问题;但是,如果此时应用服务器重新启动,而用户还没有重新登录,(也可能是用户关闭浏览器,但是仍打开原来的页面。)那么,此时该session的值就会失效,同时导致session中的session.username的值为空。对一个为null的对象的直接执行toString()操作,就会导致系统抛出(java.lang.NullPointerException)空指针异常。

解决方案:

为了确保进行操作或引用的对象非空,假若我们要对某对象进行操作或引用,我们首先去检查该对象是否已经实例化且不为空;并且在系统中加入针对对象为空时情况的处理。

如:采用String对象保存用户提交的结果;在如果涉及对象的操作时,先检测其是否为空后,检查到对象为空后,可再选择进行以下任一种处理方式:

处理方式 1) 检查到对象为空时,设置对象值为空字符串或一个默认值;

处理方式 2) 检测到对象为空时,根本不执行某操作,直接跳转到其他处理中。

处理方式 3) 检查到对象为空时,提示用户操作有错误。

将代码段2按以上方式进行改写,得到:

方式1:

String userName = request.getParameter("username");
// 该变量值为空时,转化为默认空字符串
If (userName == null)
userName = "";
If (userName.equals("root"))
{..........}

方式2:

String userName = request.getParameter("username");
// 该变量值为空时,转化为默认空字符串,不执行有关操作。
If (usreName != null)
{
If (userName.equals("root"))
{..........}
}

方式3:

String userName = request.getParameter("username");
// 该变量值为空时,转化为默认空字符串,不执行有关操作。
If (usreName == null)
{
// 提示用户输入信息为空
}

实际中,上面提供到三种处理方式也同样适用于其他异常的处理:


异常处理方式 1) 检查到异常出现,设置对象值为空字符串或一个默认值;

异常处理方式 2) 检测到异常出现,根本不执行某操作,直接跳转到其他处理中。

异常处理方式 3) 检查到异常出现,提示用户操作有错误。

Struts常见错误汇总

以下所说的struts-config.xml和ApplicationResources.properties等文件名是缺省时使用的,如果你使用了多模块,或指定了不同的资源文件名称,这些名字要做相应的修改。

1、“No bean found under attribute key XXX”

在struts-config.xml里定义了一个ActionForm,但type属性指定的类不存在,type属性的值应该是Form类的全名。或者是,在Action的定义中,name或attribute属性指定的ActionForm不存在。

2、“Cannot find bean XXX in any scope”

在Action里一般会request.setAttribute()一些对象,然后在转向的jsp文件里(用tag或request.getAttribute()方法)得到这些对象并显示出来。这个异常是说jsp要得到一个对象,但前面的Action里并没有将对象设置到request(也可以是session、servletContext)里。

可能是名字错了,请检查jsp里的tag的一般是name属性,或getAttribute()方法的参数值;或者是Action逻辑有问题没有执行setAttribute()方法就先转向了。

还有另外一个可能,纯粹是jsp文件的问题,例如会指定一个id值,然后在循环里使用这个值作为name的值,如果这两个值不同,也会出现此异常。(都是一个道理,request里没有对应的对象。)

3、“Missing message for key "XXX"”

缺少所需的资源,检查ApplicationResources.properties文件里是否有jsp文件里需要的资源,例如:

< bean:message key="msg.name.prompt"/ >

这行代码会找msg.name.prompt资源,如果AppliationResources.properties里没有这个资源就会出现本异常。在使用多模块时,要注意在模块的struts-config-xxx.xml里指定要使用的资源文件名称,否则当然什么资源也找不到,这也是一个很容易犯的错误。

4、“No getter method for property XXX of bean teacher”

这条异常信息说得很明白,jsp里要取一个bean的属性出来,但这个bean并没有这个属性。你应该检查jsp中某个标签的property属性的值。例如下面代码中的cade应该改为code才对:

< bean:write name="teacher" property="cade" filter="true"/>

5、“Cannot find ActionMappings or ActionFormBeans collection”待解决。

6、“Cannot retrieve mapping for action XXX”

在.jsp的
标签里指定action='/XXX',但这个Action并未在struts-config.xml里设置过。

7、HTTP Status 404 - /xxx/xxx.jsp

Forward的path属性指向的jsp页面不存在,请检查路径和模块,对于同一模块中的Action转向,path中不应包含模块名;模块间转向,记住使用contextRelative="true"。

8、没有任何异常信息,显示空白页面

可能是Action里使用的forward与struts-config.xml里定义的forward名称不匹配。

9、“The element type "XXX" must be terminated by the matching end-tag "XXX".”

这个是struts-config.xml文件的格式错误,仔细检查它是否是良构的xml文件,关于xml文件的格式这里就不赘述了。

10、“Servlet.init() for servlet action threw exception”

一般出现这种异常在后面会显示一个关于ActionServlet的异常堆栈信息,其中指出了异常具体出现在代码的哪一行。我曾经遇到的一次提示如下:

 java.lang.NullPointerException
   at org.apache.struts.action.ActionServlet.parseModuleConfigFile(ActionServlet.java:1003)
   at org.apache.struts.action.ActionServlet.initModuleConfig(ActionServlet.java:955)

为解决问题,先下载struts的源码包,然后在ActionServlet.java的第1003行插入断点,并对各变量进行监视。很丢人,我竟然把struts-config.xml文件弄丢了,因此出现了上面的异常,应该是和CVS同步时不小心删除的。

11、“Resources not defined for Validator”

这个是利用Validator插件做验证时可能出现的异常,这时你要检查validation.xml文件,看里面使用的资源是否确实有定义,form的名称是否正确,等等。

关键词:java,基础测试,异常问题
推荐给好友】【关闭】【收藏本文
最新五条评论
查看全部评论
评论总数 0
您的评论
用户名: 新注册) 密 码: 匿名:
·用户发表意见仅代表其个人意见,并且承担一切因发表内容引起的纠纷和责任
·本站管理人员有权在不通知用户的情况下删除不符合规定的评论信息或留做证据
·请客观的评价您所看到的资讯,提倡就事论事,杜绝漫骂和人身攻击等不文明行为